//*************************************************************************************
// 	: SQ7515_I2C.c
// 汾		: V3.2
// 		: I2C ʹú (I2CƳ)
// ע		: I2C غ㼯ڱӳ
//**************************************************************************************
#include "main.h"



//*********************************************************************
// 	: I2C0_Init()
// 	: I2C0ʼ
// ע		: I2C0 ùܽšģʽ
//			  *趨I2C0ΪSlave mode , Slave address = 0x68 
//*********************************************************************
void I2C0_Init(){

//====== I2C0ܽųʼ ======

    //--SDA0 (P0.5) ; SCL0 (P0.6)------- [ѡܽ]
    FSELR0 = (FSELR0&0x0F)|0x30;        // 趨ѡĴ0    
    PCSELR1_I2C0 = 0x00;                // 趨ΧͨѡĴ
    
    P0FC1_P5 = 1;                       // P0.5趨ΪSDA0
    P0FC2_P5 = 0;
    P0FC1_P6 = 1;                       // P0.6趨ΪSCL0
    P0FC2_P6 = 0;

/*	
    //--SDA0 (P0.4) ; SCL0 (P0.5)-------
    FSELR0 = (FSELR0&0x0F)|0x40;        // 趨ѡĴ0    
    PCSELR1_I2C0 = 0x01;                // 趨ΧͨѡĴ 
    
    P0FC1_P4 = 1;                       // P0.4趨ΪSDA0
    P0FC2_P4 = 0;
    P0FC1_P5 = 1;                       // P0.5趨ΪSCL0
    P0FC2_P5 = 0;
*/	

/*
    //--SDA0 (P2.5) ; SCL0 (P2.4)-------
    FSELR2 = (FSELR2&0x0F)|0x30;        // 趨ѡĴ2    
    PCSELR1_I2C0 = 0x02;                // 趨ΧͨѡĴ

    P2FC1_P5 = 1;                       // P2.5趨ΪSDA0
    P2FC2_P5 = 0;
    P2FC1_P4 = 1;                       // P2.4趨ΪSCL0
    P2FC2_P4 = 0;
*/	

	
/*	
    //--SDA0 (P3.2) ; SCL0 (P3.3)-------   
    FSELR3 = (FSELR3&0xF0)|0x00;        // 趨ѡĴ3
    PCSELR1_I2C0 = 0x03;                // 趨ΧͨѡĴ
    
    P3FC1_P2 = 1;                       // P3.2趨ΪSDA0
    P3FC2_P2 = 0;
    P3FC1_P3 = 1;                       // P3.3趨ΪSCL0
    P3FC2_P3 = 0;
*/


//====== I2C0 ======
    PCKEN2_I2C0 = 1;                    // I2C0
    SBI0CR1_SCK = SCK_HI_135_LO_138;    // ģʽƵʿ ; ģʽƵʽλ(SCL pin)ʱ ֮趨
	
    SBI0CR1_ACK = 1;                    // Ӧģʽ(ACK enable)
    SBI0CR1_BC = 0x00;                  // (λ)9bit = 8bit + 1bit(ACK)
	
//--- [I2C0ΪSlave] ---				*I2C0ΪSlave
	//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
	//--- SBI0CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ----
	//--- <MST>   1 : Master
	//            0 : Slave
	//--- <TRX>   1 :    ; 0: 
	//--- <BB>    1 : ʼ
	//            0 : ֹͣ
	//--- <PIN>	  1 : ȡжϷ
	//
	//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
	//--- <SWRST> ÿʼλ  
	//------------------------------------------------------------------------


    //---I2C0ΪSlave趨Slaveַ
    I2C0AR = SLAVE_ADDR << 1;           // ôģʽַ(Slaveַ)SA[7:1]
	
    //---ΪSlave mode趨 SBICR2<PIN> , <SBIM>
    SBI0CR2 = 0x18;                     // Slave mode 0001 1000

}


//*********************************************************************
// 	: I2C0_IntEnable()
// 	: I2C0ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntEnable(void){
    __ASM("DI");                        // ֹпж
    IFR_I2C0 = 0;                       // ж
    IER_I2C0 = 1;                       // I2C0ж(Enable) 
    __ASM("EI");                        // пж
}


//*********************************************************************
// 	: I2C0_IntDisable() 
// 	: ֹI2C0ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntDisable(void){
    __ASM("DI");                        // ֹпж
    IFR_I2C0 = 0;                       // ж
    IER_I2C0 = 0;                       // I2C0жϽֹ 
    __ASM("EI");                        // пж
}



//*********************************************************************
// 	: I2C1_Init()
// 	: I2C1ʼ
// ע		: I2C1 ùܽšģʽ
//			  *趨I2C1ΪMaster mode
//*********************************************************************
void I2C1_Init(){
	
//====== I2C1ܽųʼ ======

    //--SDA1 (P2.1) ; SCL1 (P2.2)-------
    P2OE_P1 = 0;
    P2OE_P2 = 0;	
    P2PU_P1 = 1;
    P2PU_P2 = 1;
    P2PD_P1 = 0;
    P2PD_P2 = 0;
      
    FSELR2 = (FSELR2&0xF0)|0x00;        // 趨ѡĴ2    
    PCSELR1_I2C1 = 0x01;                // 趨ΧͨѡĴ
    
    P2FC1_P1 = 1;                       // P2.1趨ΪSDA1
    P2FC2_P1 = 0;
    P2FC1_P2 = 1;                       // P2.2趨ΪSCL1
    P2FC2_P2 = 0;


//====== I2C1 ======
    PCKEN2_I2C1 = 1;                    // I2C1
    SBI1CR1_SCK = SCK_HI_135_LO_138;    // ģʽƵʿ ; ģʽƵʽλ(SCL pin)ʱ ֮趨
	
    SBI1CR1_ACK = 1;                    // Ӧģʽ(ACK enable)
    SBI1CR1_BC = 0x00;                  // (λ)9bit = 8bit + 1bit(ACK)	
	

//--- [I2C1ΪMaster] ---           *I2C1ΪMaster
//------------bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ----
//--- SBI1CR2 <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ----
//--- <MST>   1 : Master
//            0 : Slave
//--- <TRX>   1 :    ; 0: 
//--- <BB>    1 : ʼ
//            0 : ֹͣ
//--- <PIN>	  1 : ȡжϷ
//
//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//--- <SWRST> ÿʼλ  
//------------------------------------------------------------------------	
	//---ΪMaster mode趨 SBICR2<MST> , <PIN> , <SBIM>
    SBI1CR2 = 0xC8;                     // Master mode 1100 1000
    //SBI1CR2 = SBICR2_MST|SBICR2_PIN|SBICR2_SBIM;  // Master mode
    IFR_I2C1 = 0;                       // Д                      
    IER_I2C1 = 0;                       // I2C1 Д

}


//*********************************************************************
// 	: I2C1_IntEnable()
// 	: I2C1ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C1_IntEnable(void){
    __ASM("DI");                        // ֹпж
    IFR_I2C1 = 0;                       // ж
    IER_I2C1 = 1;                       // I2C1ж(Enable)
    __ASM("EI");                        // пж
}


//*********************************************************************
// 	: I2C1_IntDisable() 
// 	: ֹI2C1ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C1_IntDisable(void){
    __ASM("DI");                        // ֹпж
    IFR_I2C1 = 0;                       // ж
    IER_I2C1 = 0;                       // I2C1жϽֹ 
    __ASM("EI");                        // пж	
}


//*********************************************************************
// 	: I2C_Start() [Master mode]
// 	: I2CStart
// ע		: i2c : ѡһI2C
//                  I2C_0, I2C_1
//            adr : ͸Slaveװõλַ
//*********************************************************************
//SBI0CR2/SBI1CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---------
//--- <MST>   1 : Master
//            0 : Slave
//--- <TRX>   1 :    ; 0: 
//--- <BB>    1 : ʼ
//            0 : ֹͣ
//--- <PIN>	  1 : ȡжϷ
//
//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//--- <SWRST> ÿʼλ  
//----------------------------------------------------------------------
void I2C_Start(unsigned char i2c,unsigned char adr){
	
    if(i2c==I2C_0){
        unsigned char tWait_I2C0 = 0;   // Ӧʱ,ȴ֮ʼֵ
        while(SBI0SR_BB);               // SBI0SR_BB: Bus status confirms is free ; 1 :busy  0: free

//      SBI0CR1 = 0x10;                   // ***ÿһ I2C_Start趨SBI0CR1
// 		//****** Write data to the registers before the start condition is generated ******	
// 		
// 	
        SBI0DBR = adr;						// 趨 Slave Device (ID)λַ
// 		SBI0CR2 = 0xf8;                   // Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
//                                        // 1111 1000
//                                        // 趨 Master,,ʼ,ȡжϷ  Ϊģʽ
        SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
		
        while(SBI0SR_PIN){};            // ȴͷжϣʾTXɣPINΪ0
 		
// 		// ---յλcheck <LRB>ӦźACK---
// 		while(SBI0SR_LRB = 1){					
// 				tWait_I2C0++;				// Ӧ,  ==> SCKᱣ
// 				if( tWait_I2C0>250 ){		// Ӧѭ		
// 					I2C_Stop(i2c);				// I2C stop -> release SCK
// 					break;
// 				}	
// 		}
		
	}	
	else if(i2c==I2C_1){
        unsigned char tWait_I2C1 = 0;   // Ӧʱ,ȴ֮ʼֵ
        while(SBI1SR_BB);               // SBI1SR_BB: Bus status confirms is free ; 1 :busy  0: free

// 		SBI1CR1 = 0x10;                   // ***ÿһ I2C_Start趨SBI1CR1
// 		//****** Write data to the registers before the start condition is generated ******	
// 	
        SBI1DBR = adr;                  // 趨 Slave Device (ID)λַ
// 		SBI1CR2 = 0xf8;                   // Write "1" to SBI1CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
//                                        // 1111 1000
//                                        // 趨 Master,,ʼ,ȡжϷ  Ϊģʽ
		
        SBI1CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;

        while(SBI1CR2_PIN){};           // ȴͷжϣʾTXɣPINΪ0
 		
// 		// ---յλcheck <LRB>ӦźACK---
// 		while(SBI1SR_LRB = 1){					
// 				tWait_I2C1++;				// Ӧ,  ==> SCKᱣ
// 				if( tWait_I2C1>250 ){		// Ӧѭ		
// 					I2C_Stop(i2c);		    // I2C stop -> release SCK
// 					break;
// 				}	
// 		}
// 

 	}
	
}


//*********************************************************************
// 	: I2C_ReStart() [Master mode]
// 	: I2C ReStart
// ע		: i2c : ѡһI2C
//                  I2C_0, I2C_1
//            adr : ͸Slaveװõλַ
//*********************************************************************
void I2C_ReStart(unsigned char i2c,unsigned char adr){
    if(i2c==I2C_0){
// 		SBI0CR2 = 0x18;                   // Write "1" to SBI0CR2<PIN>  and <SBIM>to "1"
//                                        // 00001 1000
//                                        // 趨 ȡжϷ  Ϊģʽ
        SBI0CR2 = SBICR2_PIN|SBICR2_SBIM;
        while(SBI0SR_BB == 1);          // SBI0SR_BB: Bus status confirms is free ; 1 :busy  0: free	
        while(SBI0SR_LRB == 0);         // wait <LRB>=1
    }
    else if(i2c==I2C_1){
// 		SBI1CR2 = 0x18;						// Write "1" to SBI1CR2<PIN>  and <SBIM>to "1"
// 											// 00001 1000
// 											// 趨 ȡжϷ  Ϊģʽ
        SBI1CR2 = SBICR2_PIN|SBICR2_SBIM;
        while(SBI1SR_BB == 1);          // SBI1SR_BB: Bus status confirms is free ; 1 :busy  0: free	
        while(SBI1SR_LRB == 0);         // wait <LRB>=1
    }

    I2C_Start(i2c,adr);                 // ͳ start + addressѶ

}


//*********************************************************************
// 	: I2C_Stop() [Master mode]
// 	: I2C Stop
// ע		: i2c :ѡһI2C
//                 I2C_0, I2C_1
//*********************************************************************
//SBI0CR2/SBI1CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---        <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---
//--- <MST>   1 : Master
//            0 : Slave
//--- <TRX>   1 :    ; 0: 
//--- <BB>    1 : ʼ
//            0 : ֹͣ
//--- <PIN>	  1 : ȡжϷ
//
//--- <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//--- <SWRST> ÿʼλ  
//----------------------------------------------------------------------
void I2C_Stop(unsigned char i2c){

    if(i2c==I2C_0){
// 	SBI0CR2 = 0xd8;                       // Set SBI0CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
//                                        // 1101 1000
//                                        // 趨 Master,,ֹͣ,ȡжϷ  ΪPortģʽ
        SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_PIN|SBICR2_SBIM;
	
        while(SBI0SR_BB);               // Bus free,SBI0SR_BB: Bus status confirms is free ; 1 :busy  0: free
	}	
    else if(i2c==I2C_1){
// 		SBI0CR2 = 0xd8;                   // Set SBI0CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
//                                        // 1101 1000
//                                        // 趨 Master,,ֹͣ,ȡжϷ  ΪPortģʽ
        SBI1CR2 = SBICR2_MST|SBICR2_TX|SBICR2_PIN|SBICR2_SBIM;
        while(SBI1SR_BB);              	 	  // Bus free,SBI1SR_BB: Bus status confirms is free ; 1 :busy  0: free
	}
}

//*********************************************************************
// 	: I2C_TXOneByte() [Master mode]
// 	: I2C һByte
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//            TxBuf: 
//*********************************************************************
void I2C_TXOneByte(unsigned char i2c,unsigned char TxBuf){
	
    if(i2c==I2C_0){
        SBI0DBR = TxBuf;
        SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
        while(SBI0CR2_PIN);             // TX
	}
    else if(i2c==I2C_1){
        SBI1DBR = TxBuf;
        SBI1CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
        while(SBI1CR2_PIN);             // TX
	}
}

//*********************************************************************
// 	: I2C_RXOneByte() [Master mode]
// 	: I2C һByte
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//            return: ش
//*********************************************************************
unsigned char I2C_RXOneByte(unsigned char i2c){

	if(i2c==I2C_0){
        SBI0CR2 = SBICR2_MST|SBICR2_RX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
        SBI0DBR = 0x00;                 // Buf
        while(SBI0CR2_PIN == 1);        
        return SBI0DBR;
    }
    else if(i2c==I2C_1){
        SBI1CR2 = SBICR2_MST|SBICR2_RX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
        SBI1DBR = 0x00;                 // Buf
        while(SBI1CR2_PIN == 1);
        return SBI1DBR;
	}
	else{
        return 0;
    }
}


//*********************************************************************
// 	: IsAck()
// 	: I2CǷACK
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//            return : 1 : NACK   0: ACK
//*********************************************************************
unsigned char IsAck(unsigned char i2c){

    if(i2c==I2C_0){
        return SBI0SR_LRB;
    }
    else if(i2c==I2C_1){
        return SBI1SR_LRB;
    }

    return I2C_NACK;
}


//*********************************************************************
// 	: I2C_AckEnable()
// 	: I2CǷһbitACKѶ
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//            enable : 1     0 ֹ
//*********************************************************************
void I2C_AckEnable(unsigned char i2c, unsigned char enable){
    if(i2c==I2C_0){
        SBI0CR1_ACK = enable;           // I2C0 һbitACKѶ
    }
    else if(i2c==I2C_1){
        SBI1CR1_ACK = enable;           // I2C1 һbitACKѶ
    }
}


//*********************************************************************
// 	: I2C_BufCount()
// 	: I2Cbit
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//            bufcount : 
//                   BC_8bit      0x00
//                   BC_1bit      0x01
//                   BC_2bit      0x02
//                   BC_3bit      0x03
//                   BC_4bit      0x04
//                   BC_5bit      0x05
//                   BC_6bit      0x06
//                   BC_7bit      0x07 
//*********************************************************************
void I2C_BufCount(unsigned char i2c, unsigned char bufcount){
    if(i2c==I2C_0){
        SBI0CR1_BC = bufcount;
    }
    else if(i2c==I2C_1){
        SBI1CR1_BC = bufcount;
	}
}


//*********************************************************************
// 	: I2C_ReadState()
// 	: ȡI2C֮״̬
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1

//*********************************************************************
unsigned char I2C_ReadState(unsigned char i2c){
	if(i2c==I2C_0){
        return SBI0SR;                  // ȡI2C0֮״̬
    }
    else if(i2c==I2C_1){
        return SBI1SR;                  // ȡI2C1֮״̬
	}
    else{ 
        return 0;
    }
}


//*********************************************************************
// 	: I2C_SetBufvalue()
// 	: 趨I2C buffer
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//            data:  buffer
//*********************************************************************
void I2C_SetBufvalue(unsigned char i2c,unsigned char data){
    if(i2c==I2C_0){
        SBI0DBR = data;
    }
    else if(i2c==I2C_1){
        SBI1DBR = data;
    }
}

//*********************************************************************
// 	: I2C_ReadBufvalue()
// 	: I2C buffer
// ע		: i2c :   ѡһI2C
//                    I2C_0, I2C_1
//            return: buffer
//*********************************************************************
unsigned char I2C_ReadBufvalue(unsigned char i2c){
    if(i2c==I2C_0){
        return SBI0DBR;
    }
    else if(i2c==I2C_1){
        return SBI1DBR;
    }
    else{
        return 0;
    }
}


//*********************************************************************
// 	: I2C_FinishSlaveTx() [Slave mode]
// 	: I2C Slaveɳ,ҪΪͷI2C,һI2C˳ս
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//*********************************************************************
void I2C_FinishSlaveTx(unsigned char i2c){
	if(i2c==I2C_0){
        SBI0CR2 = 0x58;
        SBI0CR2 = 0x18;
    }
    else if(i2c==I2C_1){
        SBI1CR2 = 0x58;
        SBI1CR2 = 0x18;
	}

}


//*********************************************************************
// 	: I2C_Reset()
// 	: I2C software reset. SBI0CR1,I2C0AR,SBI0CR2 ,SBI0CR2<SBIM>
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//*********************************************************************
void I2C_Reset(unsigned char i2c){
	if(i2c==I2C_0){
        SBI0CR2 = 0x1A;
        SBI0CR2 = 0x19;
    }
    else if(i2c==I2C_1){
        SBI1CR2 = 0x1A;
        SBI1CR2 = 0x19;
    }

}


//*********************************************************************
// 	: __interrupt IntI2C0()
// 	: I2C0 жӳ
// ע		:
//*********************************************************************
void __interrupt IntI2C0(void){
    __asm("NOP");                       // ָ

    I2C_Slave_Int(I2C_0,&i2c_slave);
}


//*********************************************************************
// 	: __interrupt IntI2C1()
// 	: I2C1 жӳ
// ע		:
//*********************************************************************
void __interrupt IntI2C1(void){
    __asm("NOP");                       // ָ

	
}


//*********************************************************************
// 	: I2C_Master_Write()
// 	: 
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//*********************************************************************
unsigned char I2C_Master_Write(unsigned char i2c,I2C_MasterPacket* pi2c){
    unsigned char cnt;
	
    I2C_Start(i2c,(unsigned char)(pi2c->adr<<1)|I2C_Write);
    if(IsAck(i2c)==I2C_NACK){
        I2C_Stop(i2c);
        return 0;
    }

    I2C_TXOneByte(i2c,pi2c->cmd);       // I2C һByte
    if(IsAck(i2c)==I2C_NACK){
        I2C_Stop(i2c);
        return 0;
    }

    for(cnt=0;cnt<pi2c->len;cnt++){
        I2C_TXOneByte(i2c,pi2c->buf[cnt]);  // I2C һByte

        if(IsAck(i2c)==I2C_NACK){
            I2C_Stop(i2c);
            return 0;
        }
    }

	I2C_Stop(i2c);

	return 1;
}


//*********************************************************************
// 	: I2C_Master_Read()
// 	: 
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//*********************************************************************
unsigned char I2C_Master_Read(unsigned char i2c,I2C_MasterPacket* pi2c){
    unsigned char cnt;
	
    I2C_Start(i2c,(unsigned char)(pi2c->adr<<1)|I2C_Write); // I2CStart
	
    if(IsAck(i2c)==I2C_NACK){           // I2CǷACKΪNACKI2C ִзStop
        I2C_Stop(i2c);
        return 0;
	}

    I2C_TXOneByte(i2c,pi2c->cmd);       // I2C һByte (cmd)
	
    if(IsAck(i2c)==I2C_NACK){           // I2CǷACKΪNACKI2C ִзStop
        I2C_Stop(i2c);
        return 0;
    }
	
    I2C_ReStart(i2c,(unsigned char)(pi2c->adr<<1)|I2C_Read);    // I2C ReStart
	
    if(IsAck(i2c)==I2C_NACK){           // I2CǷACKΪNACKI2C ִзStop
        I2C_Stop(i2c);
        return 0;
    }

    for(cnt=0;cnt<pi2c->len;cnt++){
        if(cnt == pi2c->len-1){
            I2C_AckEnable(i2c,0);                   // ACK disable 
            I2C_BufCount(i2c,BC_8bit);              // 趨8bit
            pi2c->buf[cnt] = I2C_RXOneByte(i2c);
            I2C_BufCount(i2c,BC_1bit);              // 1bit ACK
            I2C_TXOneByte(i2c,0xFF);                // дNack dataΪ0xFF

            I2C_AckEnable(i2c,1);                   // ACK enable 
            I2C_BufCount(i2c,BC_8bit);              // 8bit
        }
        else{
            pi2c->buf[cnt] = I2C_RXOneByte(i2c);    // 8bit+1bit ACK
        }
    }

	I2C_Stop(i2c);                      // I2C ִзStop

	return 1;
}


//*********************************************************************
// 	: I2C_Slave_Int()
// 	: 
// ע		: i2c :  ѡһI2C
//                   I2C_0, I2C_1
//*********************************************************************
void I2C_Slave_Int(unsigned char i2c,I2C_SlavePacket* pi2c){
    unsigned char tmp;

    if(I2C_ReadState(i2c)&SBISR_TX){
        // ͳ
        if(I2C_ReadState(i2c)&SBISR_AAS){
            // slaveַǺ
            pi2c->status = I2C_Slave_read;
            // I2C readҪ̎ĳ
            if(pi2c->cmd == 0x09){
                pi2c->buf[0] = 0x12;
                pi2c->buf[1] = 0x34;
                pi2c->len = 2;          // ͳLO0
            }
            else if(pi2c->cmd == 0x0A){
                pi2c->buf[0] = 0x55;
                pi2c->buf[1] = 0xAA;
                pi2c->len = 2;          // ͳLO2
            }
            else{
                pi2c->len = 0;          // ֧Ԯָ,ͳLO0
            }

			// QǷͳһPY
            pi2c->pointer= 0;
            if(pi2c->pointer >= pi2c->len){   // _JǷYҪͳ
                I2C_SetBufvalue(i2c,0xFF);    // ͳdummy data
            }
            else{
                I2C_SetBufvalue(i2c,pi2c->buf[pi2c->pointer]);
            }
        }
        else{
            if(I2C_ReadState(i2c)&SBISR_LRB){
                I2C_SetBufvalue(i2c,0x00);		 // Clear buf
                I2C_FinishSlaveTx(i2c);
            }
            else{
                if(pi2c->pointer >= pi2c->len){
                    I2C_SetBufvalue(i2c,0xFF);
                }
                else{
                    I2C_SetBufvalue(i2c,pi2c->buf[pi2c->pointer]);
                }
            }
        }

        pi2c->pointer++;
    }
    else{
        // 
        if(I2C_ReadState(i2c)&SBISR_AAS){
            // slaveַǺ
            pi2c->pointer = 0;
            pi2c->status = I2C_Slave_adr;
            tmp = I2C_ReadBufvalue(i2c);
            I2C_SetBufvalue(i2c,0x00);          // Clear buf
        }
        else{
            if(pi2c->status == I2C_Slave_adr){
                pi2c->cmd = I2C_ReadBufvalue(i2c);
                pi2c->status = I2C_Slave_cmd;
                I2C_SetBufvalue(i2c,0x00);      // Clear buf
            }
            else{
                pi2c->buf[pi2c->pointer] = I2C_ReadBufvalue(i2c);
                pi2c->pointer++;
                I2C_SetBufvalue(i2c,0x00);      // Clear buf
            }
        }
    }
}

/* ------------------------- ļβ ---------------------------- */
